ext WaitTimer_

tempo equ 200

Count equ 2
Channel_Ptr equ 0
Channel_Start equ Channel_Ptr+2
Channel_Tone equ Channel_Start+2
Channel_Len equ Channel_Tone+2
UnitSize equ Channel_Len+1


dseg
Channels: public Channels
    defs UnitSize*Count
time:
    defw 0


cseg
InitSound_: public InitSound_
    push af | push hl
        di
            ld hl,0
            ld (time),hl

            ld ix,Channels
            ld b,Count
            ld de,UnitSize
            xor a
            do
                ld (ix+Channel_Ptr),a
                ld (ix+Channel_Ptr+1),a
                ld (ix+Channel_Tone),a
                ld (ix+Channel_Tone+1),a
                add ix,de
            dwnz
        ei
    pop hl | pop af
ret


ToneOn:                                                                         public ToneOn
; in
;   hl : cycle
    push af
        ld a,36h
        ld (0e007h),a
        ld a,l
        ld (0e004h),a
        ld a,h
        ld (0e004h),a
        ld a,1
        ld (0e008h),a
    pop af
ret

ToneOff:
    xor a
    ld (0e008h),a
ret


SoundHandler: public SoundHandler
    push hl | push de
        ld hl,(time)
        ld de,-tempo
        add hl,de
        if nc
            push hl | push bc | push ix
                ld ix,Channels
                ld b,Count
                do
                    ld l,(ix+Channel_Ptr)
                    ld h,(ix+Channel_Ptr+1)
                    ld a,l
                    or h
                    if nz
                        dec (ix+Channel_Len)                        
                        if z
                            continue:
                            ld a,(hl)
                            or a
                            if z
                                ; end
                                ld (ix+Channel_Ptr),a
                                ld (ix+Channel_Ptr+1),a
                                offch:
                                xor a
                                ld (ix+Channel_Tone),a
                                ld (ix+Channel_Tone+1),a
                                ld a,b
                                cp 1
                                if z
                                    ld l,(ix+Channel_Tone-UnitSize)
                                    ld h,(ix+Channel_Tone-UnitSize+1)
                                    ld a,l
                                    or h
                                    if nz
                                        call ToneOn
                                        jr next
                                    endif
                                endif
                                call ToneOff
                                jr next
                            endif
                            inc a
                            if z 
                                ; repeat
                                ld l,(ix+Channel_Start)
                                ld h,(ix+Channel_Start+1)
                                jr continue
                            endif
                            dec a
                            ld (ix+Channel_Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (ix+Channel_Ptr),l
                            ld (ix+Channel_Ptr+1),h
                            or a
                            jr z,offch
                            dec a
                            add a,a
                            ld e,a
                            ld d,0
                            ld hl,cycles
                            add hl,de
                            ld a,(hl)
                            inc hl
                            ld h,(hl)
                            ld l,a
                            ld (ix+Channel_Tone),l
                            ld (ix+Channel_Tone+1),h
                            ld a,b
                            cp 1
                            if z
                                ld a,(ix+Channel_Tone-UnitSize)
                                or (ix+Channel_Tone-UnitSize+1)
                                if nz
                                    jr next
                                endif
                            endif
                            call ToneOn
                        endif
                    endif
                    next:
                    ld de,UnitSize
                    add ix,de
                dwnz
            pop ix | pop bc | pop hl
            ld de,600/2
            add hl,de
        endif
        ld (time),hl
    pop de | pop hl
ret


Melody:
    di
        ld (Channels+Channel_Ptr),hl
        ld a,1
        ld (Channels+Channel_Len),a
    ei
ret

MelodyWait:
    call Melody
    do
        ld hl,(Channels+Channel_Ptr)
        ld a,l
        or h
    while nz | wend
ret 


fire_notes:
    defb 1,F5, 1,D5S, 1,C5S, 1,B4, 1,A4, 1,G5, 0
Sound_Fire_: public Sound_Fire_
    push af | push hl
        ld hl,fire_notes
        call Melody
    pop hl | pop af
ret


hit_notes:
    defb 1,F4, 1,G4, 1,A4, 1,B4, 1,C5, 1,D5, 1,E5, 1,F5
    defb 0 
Sound_Hit_: public Sound_Hit_
    push af | push hl
        ld hl,hit_notes
        call Melody
    pop hl | pop af
ret


loose_notes:
    defb 1,F5, 1,E5, 1,D5, 1,C5, 1,B4, 1,A4, 1,G4, 1,F4, 0
Sound_Loose_: public Sound_Loose_
    push af | push hl
        ld hl,loose_notes
        call MelodyWait
    pop hl | pop af
ret


up_notes:
    defb 1,C4, 1, C4S, 1,D4, 1,F4, 1,A4, 1,C5, 0
Sound_Up_: public Sound_Up_
    push af | push hl
        ld hl,up_notes
        call Melody
    pop hl | pop af
ret


start_notes: 
	defb 5,E4,1,0, 11,F4S,1,0, 11,G4,1,0
	defb 11,G4,1,0, 5,E4,1,0, 11,A4,1,0
	defb 11,A4,1,0, 5,G4,1,0, 17,A4,1,0
	defb 35,B4,1,0
	defb 12,0
    defb 0
Sound_Start_: public Sound_Start_
    push af | push hl
        ld hl,start_notes
        call MelodyWait
    pop hl | pop af
ret


over_notes: 
	defb 11,E4,1,0, 5,B3,1,0, 5,E4,1,0
	defb 5,D4,1,0, 5,C4,1,0, 5,B3,1,0, 5,A3,1,0
	defb 35,B3,1,0
	defb 12,0
    defb 0
Sound_GameOver_: 
    public Sound_GameOver_
    push af | push hl
        ld hl,over_notes
        call MelodyWait
    pop hl | pop af
ret


BGM_B:
	defb 17,E4,1,0, 17,F4S,1,0
	defb 23,G4,1,0
	defb 11,G4,1,0, 11,F4S,1,0
	defb 11,G4,1,0, 17,F4S,1,0
	defb 17,D4,1,0, 35,D4,1,0
	defb 24,0
	defb 17,E4,1,0, 17,F4S,1,0
	defb 23,G4,1,0
	defb 11,G4,1,0, 11,F4S,1,0
	defb 11,G4,1,0, 17,D5,1,0
	defb 17,A4,1,0, 35,A4,1,0
	defb 24,0
	defb 17,C5,1,0, 17,B4,1,0
	defb 23,C5,1,0
	defb 11,C5,1,0, 11,B4,1,0
	defb 11,C5,1,0, 17,B4,1,0
	defb 17,G4,1,0, 35,G4,1,0
	defb 24,0
	defb 5,E4,1,0, 5,E4,1,0, 5,F4S,1,0, 11,G4,1,0
	defb 11,G4,1,0, 5,G4,1,0, 5,F4S,1,0
	defb 5,F4S,1,0, 5,G4,1,0, 11,A4,1,0
	defb 11,A4,1,0, 5,A4,1,0, 5,G4,1,0
	defb 5,G4,1,0, 5,A4,1,0, 11,B4,1,0
	defb 11,B4,1,0, 5,B4,1,0, 5,C5,1,0
	defb 11,C5,1,0, 17,B4,1,0
	defb 12,0
    defb 0ffh

StartBGM_: public StartBGM_
    push af | push hl
        di
            ld a,1
            ld hl,BGM_B
            ld (Channels+UnitSize*1+Channel_Start),hl
            ld (Channels+UnitSize*1+Channel_Ptr),hl
            ld (Channels+UnitSize*1+Channel_Len),a
        ei
    pop hl | pop af
ret

StopBGM_: public StopBGM_
    push af | push hl | push bc
        di
            ld hl,0
            ld (Channels+UnitSize*0+Channel_Ptr),hl
            ld (Channels+UnitSize*0+Channel_Tone),hl
            ld (Channels+UnitSize*1+Channel_Ptr),hl
            ld (Channels+UnitSize*1+Channel_Tone),hl
            call ToneOff
        ei
    pop bc | pop hl | pop af
ret


G3 equ 1
G3S equ 2
A3 equ 3
A3S equ 4
B3 equ 5
C4 equ 6
C4S equ 7
D4 equ 8
D4S equ 9
E4 equ 10
F4 equ 11
F4S equ 12
G4 equ 13
G4S equ 14
A4 equ 15
A4S equ 16
B4 equ 17
C5 equ 18
C5S equ 19
D5 equ 20
D5S equ 21
E5 equ 22
F5 equ 23
F5S equ 24
G5 equ 25

cycles:
defw 4565 ; G3
defw 4309 ; G#3
defw 4067 ; A3
defw 3839 ; A#3
defw 3623 ; B3
defw 3420 ; C4
defw 3228 ; C#4
defw 3047 ; D4
defw 2876 ; D#4
defw 2714 ; E4
defw 2562 ; F4
defw 2418 ; F#4
defw 2282 ; G4
defw 2154 ; G#4
defw 2033 ; A4
defw 1919 ; A#4
defw 1811 ; B4
defw 1710 ; C5
defw 1614 ; C#5
defw 1523 ; D5
defw 1438 ; D#5
defw 1357 ; E5
defw 1281 ; F5
defw 1209 ; F#5
defw 1141 ; G5
